﻿--To change--
wmshape = "gloss" 
showDate = true
wmpingnotice = true
pop = ChatFrame1
wfnotice = true
scale = 1
--To change--

local wname = "|cff3399FFw|rMmap|r"
local wversion = "|cffFF0000v4.7|r"
local m = Minimap
local wf = WatchFrame
local wfmove = false 
local font = "FONTS\\FRIZQT__.ttf"
local wmping = CreateFrame("frame")
local MiniFrame = CreateFrame("Button", "Mover", UIParent, "UIPanelButtonTemplate")

-- Hide stuff
local stuff = {
    "MiniMapVoiceChatFrame",
    "MiniMapWorldMapButton",
    "MinimapBorderTop",
    "MinimapNorthTag",
    "MinimapZoomOut",
    "MinimapZoomIn",
    "MiniMapTracking",
    "MinimapBorder",
    "GameTimeFrame",
}
for i,v in pairs(stuff) do
  getglobal(v).Show = function() end
  getglobal(v):Hide()
end

--shape
function Getwmshape()
	return wmshape
end

local t = m:CreateTexture(nil, 'ARTWORK')
t:SetPoint('TOPLEFT', m, 'TOPLEFT', -12, 12)
t:SetPoint('BOTTOMRIGHT', m, 'BOTTOMRIGHT', 12, -12)
t:SetBlendMode('BLEND')

local function SHAPE(msg)
	msg = msg:lower()
	if msg == "gold" or msg == "gloss" or msg == "arrow" or msg == "tec" then
		m:SetMaskTexture([[Interface\AddOns\wMmap\texture\mask-]] .. msg)
		t:SetTexture([[Interface\AddOns\wMmap\texture\]] .. msg)
		print(wname.."|cFF00FFFF: Shape set to " .. msg .. ".|r")
	else
		print(wname.."|cFF00FFFF: Type /shape gold or /shape gloss or /shape arrow or /shape tec to change the shape.|r")
	end
end

SLASH_SHAPE1 = "/shape"
SlashCmdList["SHAPE"] = SHAPE

SHAPE(wmshape)

--MENUCOMMANDS
SlashCmdList["wMmap"] = function(arg1)
	if arg1:lower() == "reset" then
		MiniFrame:ClearAllPoints()
		MiniFrame:SetPoint("TOPRIGHT", UIParent, -15, 0)
                print(wname.."|cFF00FFFF: reset.|r")
	elseif arg1:lower() == "rl" then
		ReloadUI()
	elseif arg1:lower() == "unlock" then
		MiniFrame:Show()
                print(wname.."|cFF00FFFF: unlocked for drag.|r")
	elseif arg1:lower() == "lock" then
		MiniFrame:Hide()
                print(wname.."|cFF00FFFF: locked.|r")
	else
	print(wname..": Use Left Mouse Button to ping the minimap")
	print(wname..": Use Middle Mouse Button to open calander")
	print(wname..": Use Right Mouse Button to show tracking dropdown menu")
	print(wname..": Type |cffFF0000/wm unlock|r to move the Minimap")
	print(wname..": Type |cffFF0000/wm lock|r to lock the Minimap from moving")
	print(wname..": Type |cffFF0000/wm reset|r to set minimap to default position")
        print(wname..": Type |cffFF0000/wf|r Use Left Mouse Button to move Quest Frame, and to lock and unlock")
	print(wname..": Type |cFF00FFFF /shape shape here|r Change the shape. Example: |cFFFFFF00/shape gold|r or |cFFFFFF00/shape gloss|r or |cFFFFFF00/shape arrow|r or |cFFFFFF00/shape tec|r")
	print(wname..": Type |cffFF0000/wm rl|r to reload the ui")
	end
end
SLASH_wMmap1 = "/wm"

-- WatchFrame
if wfnotice then
wf:SetMovable(true);
wf:SetClampedToScreen(false); 
wf:ClearAllPoints()
wf:SetPoint("TOPRIGHT", m, "BOTTOMRIGHT", 0, -80)
wf:SetUserPlaced(true)
wf.SetPoint = function() end
wf:SetScale(0.8)

local function WATCHFRAMELOCK()
	if wfmove == false then
		wfmove = true
		print(wname.."|cFF00FFFF: Quest Watch Frame unlocked for drag.|r")
		wf:EnableMouse(true);
		wf:RegisterForDrag("LeftButton"); 
		wf:SetScript("OnDragStart", wf.StartMoving); 
		wf:SetScript("OnDragStop", wf.StopMovingOrSizing);
	elseif wfmove == true then
		wf:EnableMouse(false);
		wfmove = false
		print(wname.."|cFF00FFFF: Quest Watch Frame locked.|r")
	end
end

SLASH_WATCHFRAMELOCK1 = "/wf"
SlashCmdList["WATCHFRAMELOCK"] = WATCHFRAMELOCK

end
--TextStuff
MinimapZoneTextButton:SetPoint("TOP", m, "TOP", 0, 4)
MinimapZoneTextButton:SetFrameStrata("HIGH")
MinimapZoneText:SetFont(font, 10, "OUTLINE")

LoadAddOn('Blizzard_TimeManager')
local clockFrame, clockTime = TimeManagerClockButton:GetRegions()
clockFrame:Hide()
clockTime:Show()
clockTime:SetFont(font, 14)
    if(CalendarGetNumPendingInvites() > 0) then
		clockTime:SetTextColor(0, 1, 0) -- Red
	else
		clockTime:SetTextColor(1, 1, 1) -- White
    end
TimeManagerClockButton:SetPoint("CENTER", m, "BOTTOM", -2, 2)

if showDate then
	local fdate = CreateFrame("Frame", nil, UIParent)

	fdate.text = fdate:CreateFontString(nil, "BACKGROUND", "GameFontNormalSmall")
	fdate.text:SetPoint("TOP", m, "BOTTOM", -3, -4)

	fdate:SetScript("OnUpdate", function()
		fdate.text:SetText(date("%a %d/%b"))
	end)
end

--Zoom
m:SetZoom(0)
m:EnableMouseWheel(true)
	m:SetScript("OnMouseWheel", function()
		if arg1 > 0 then Minimap_ZoomIn() else Minimap_ZoomOut() end
	end)
--SetClicks
m:SetScript('OnMouseUp', function(self, button)
    if (button == 'RightButton') then
        ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self, - (m:GetWidth() * 0.7), -3)
    elseif (button == 'MiddleButton') then
        ToggleCalendar()
    else
        Minimap_OnClick(self)
    end
end)

--BATTLEGROUND
MiniMapBattlefieldFrame:ClearAllPoints()
MiniMapBattlefieldFrame:SetPoint("TOP", m, 0, -3)
MiniMapBattlefieldFrame:SetScale(.9)
MiniMapBattlefieldBorder:Hide()
--InstanceDifficulty
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetPoint("TOPRIGHT", m, 0, -4)
MiniMapInstanceDifficulty:SetScale(.9)
MiniMapInstanceDifficulty:SetFrameStrata("HIGH")
--LFGFRAME
function UpdateLFG()
MiniMapLFGFrame:ClearAllPoints()
MiniMapLFGFrame:SetPoint("BOTTOMRIGHT", m, 3, -3)
MiniMapLFGFrame:SetScale(.9)
    LFDSearchStatus:ClearAllPoints()
    LFDSearchStatus:SetPoint("TOPRIGHT", MiniMapLFGFrame, 0, 130)
    LFDSearchStatus:SetScale(.8)
end
MiniMapLFGFrameBorder:SetAlpha(0)
DropDownList1:SetClampedToScreen(true)
hooksecurefunc("MiniMapLFG_UpdateIsShown", UpdateLFG)
--MAILFRAME
MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetPoint('BOTTOM', m, 0, 18)
MiniMapMailFrame:SetHeight(10)
MiniMapMailBorder:Hide()
MiniMapMailIcon:SetTexture("Interface\\AddOns\\wMmap\\texture\\mail")

-- Make it all moveable
MiniFrame:SetHeight(15)
MiniFrame:SetWidth(150)
MiniFrame:SetText("Anchor")
MiniFrame:Hide()
MiniFrame:ClearAllPoints()
MiniFrame:SetPoint("TOPRIGHT", UIParent, -15, -5)
m:SetScale(scale)
m:ClearAllPoints()
m:SetPoint("TOP", MiniFrame, "BOTTOM", 0,0)

function wmmove(frame)
	frame:SetMovable(true)
	frame:SetClampedToScreen(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", frame.StartMoving)
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
end

wmmove(MiniFrame)

--Hook
m:SetFrameStrata("BACKGROUND")
wmping:RegisterEvent("MINIMAP_PING")
wmping:SetScript("OnEvent", function(self,event,unit) if wmpingnotice then local ping_name = UnitName(unit) pop:AddMessage(wname.." pinged by: |cffFF0000" .. ping_name .. "|r") end end)
print(wname..": " .. wversion .. " Loaded - |cff3399FF/wm|r for more information")